package pipe.gui;
import pipe.dataLayer.*;
import javax.swing.JFrame;
import javax.swing.JTree;
import java.awt.Toolkit;
import java.awt.Dimension;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import java.awt.*;
import java.awt.event.*;
import java.util.Observer;
import java.util.Observable;
import java.awt.BorderLayout;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.JSplitPane;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import java.io.*;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.GraphicsEnvironment;
import java.awt.Point;
import java.util.*;


public class CreateGui implements Constants {

  public static GuiFrame appGui;
  private static CreateGui theApp; //the application object
  private DataLayer[] appModel; //the data model
  private GuiView[] appView;// the view
  private File[] appFile;
  private Animator animator;
  private JTabbedPane appTab;
  private int freeSpace;


  /** The Module will go in the top pane, the animation window in the bottom pane */
  public JSplitPane leftPane;
  public AnimationHistory animBox;
  public JScrollPane scroller;

  public void init(){

    appGui = new GuiFrame("PIPE: Platform Independent Petri Net Editor", this);
    //initialisation of appGui
    Toolkit theKit=appGui.getToolkit();
    Dimension wndSize = theKit.getScreenSize();
    appGui.setBounds(wndSize.width/10, wndSize.height/12,750,600);
    //appGui.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    appGui.getContentPane().setBackground(DEFAULT_BACKGROUND_COLOR);
    //	appGui.setBounds(wndSize.width/10, wndSize.height/12,750,600);
    // Dimensions
    final Toolkit mainToolKit = appGui.getToolkit(); // Get the window toolkit
    final Dimension windowSize = mainToolKit.getScreenSize(); // Get screen size
    final Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint(); // Get screen center
    // Specify width as percentage of current screen
    final int windowWidth = (windowSize.width*87)/100; // Window width in pixels
    // Specify height as percentage of current screen
    final int windowHeight = (windowSize.height*87)/100; // Window height in pixels
    final int windowTopLeftCornerX = center.x-windowWidth/2; // Set window position
    final int windowTopLeftCornerY = center.y-windowHeight/2; // Distance from top left corner of screen

    appGui.setBounds(windowTopLeftCornerX, windowTopLeftCornerY, windowWidth, windowHeight);
    //appGui.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    appGui.getContentPane().setBackground(DEFAULT_BACKGROUND_COLOR);


    appTab = new JTabbedPane();

    appGui.addWindowListener(new WindowHandler());//Add window listener
    appModel = new DataLayer[5];
    appView = new GuiView[5];
    appFile = new File[5];
    appModel[0] = new DataLayer();//create the model
    appView[0] = new GuiView(this); //create the view
    appModel[0].addObserver((Observer) appView[0]);//register the view with the model
    animator = new Animator(this,appGui, appView[0], appModel[0]);//create the animator
    if(animator== null){
      //System.out.println("Animator after CreateGui initialisation: "+ animator);
    }
    appTab.addTab("PetriNet...",appView[0]);
    appGui.setObjects(); //sets view and model in GuiFrame
    appGui.setTab();   // sets Tab properties

    // create the tree
    ModuleManager moduleManager = new ModuleManager(this);
    JTree moduleTree = moduleManager.getModuleTree();

    moduleTree.setBorder(BorderFactory.createCompoundBorder(
        BorderFactory.createLineBorder(Color.darkGray),
        BorderFactory.createEmptyBorder(2,2,4,2)));



    leftPane = new JSplitPane();
    leftPane.setTopComponent(moduleTree);
    leftPane.setBottomComponent(null);
    leftPane.setOrientation(JSplitPane.VERTICAL_SPLIT);
    leftPane.setDividerLocation(0);


    JSplitPane pane = new JSplitPane();
    pane.setLeftComponent(leftPane);
    pane.setBottomComponent(appTab);

    appGui.getContentPane().add(pane);


    //HAK-Register window as an observer
    appModel[0].addObserver((Observer)appGui);
    appView[0].setVisible(true);
    appGui.setVisible(true);


  }
  //HAK-method to pass model into window
  public void insertModel(DataLayer newNet){
    //    net = newNet;
    //    net.addObserver((Observer)view);    // Store the new net
    //    net.addObserver((Observer)window);  // Add the view as Observerx
    //    net.addObserver((Observer)window);  // Add the app window as observer
    //    view.repaint();                     // Repaint the view
  }

  public GuiFrame getApp(){  //returns a reference to the application
    return appGui;
  }

  public DataLayer getModel(){
    if (appModel[appTab.getSelectedIndex()]==null){
      appModel[appTab.getSelectedIndex()] = new DataLayer();//create the model
    }
    return appModel[appTab.getSelectedIndex()];

  }

  public void nullModel(int place){
    for(int counter=place;counter<4;counter++){
      appModel[counter]=appModel[counter+1];
    }
    appModel[4] = null;//null the model

  }

  public void nullView(int place){
    for(int counter=place;counter<4;counter++){
      appView[counter]=appView[counter+1];
    }
    appView[4] = null;//null the model

  }

  public void setTabTitles(int place){
    for(int counter=place;counter<4;counter++){
      appModel[counter]=appModel[counter+1];
    }
    appModel[4] = null;//null the model

  }


  public GuiView getView(){
    if (appView[appTab.getSelectedIndex()]==null){
      appView[appTab.getSelectedIndex()] = new GuiView(this);
    }
    return appView[appTab.getSelectedIndex()];
  }

  public DataLayer getModel(int place){
    if (appModel[place]==null){
      appModel[place] = new DataLayer();//create the model
    }
    return appModel[place];

  }

  public GuiView getView(int place){
    if (appView[place]==null){
      appView[place] = new GuiView(this);
    }
    return appView[place];
  }


  public File getFile(){

    if (appFile[appTab.getSelectedIndex()]==null){
      return null;
    };
    return appFile[appTab.getSelectedIndex()];
  }

  public void setFile(File modelfile, int fileNo){

    if (appFile[fileNo]==null){
      appFile[fileNo] = new File(modelfile.getPath());
    }
    appFile[fileNo] = modelfile;
  }

  public int getFreeSpace(){

    for (int counter = 0;counter<5;counter++){
      if (appModel[counter]==null){
        return counter;
      }
    }
    return -1;
  }







  public JTabbedPane getTab(){
    return appTab;
  }

  public Animator getAnimator(){
    // System.out.println("CreateGui.getAnimator: "+animator);
    return animator;
  }




  class WindowHandler extends WindowAdapter{
    //Handler for window closing event
    public void windowClosing(WindowEvent e){
      appGui.checkForSaveAll();
      appGui.dispose();
      System.exit(0);
    }

  }

  /** returns the current dataLayer object - used to get a reference to pass to the modules */
  public DataLayer currentPNMLData() {
    //System.out.println("CREATEGUI: returning current dataLayer object");
    return appModel[appTab.getSelectedIndex()];
  }

  /** Creates a new animationHistory text area, and returns a reference to it*/
  public void addAnimationHistory() {
    try {


      animBox = new AnimationHistory("Animation history\n");
      animBox.setEditable(false);

      scroller = new JScrollPane(animBox);

      leftPane.setBottomComponent(scroller);

      leftPane.setDividerLocation(0.5);
    } catch (javax.swing.text.BadLocationException be){
      be.printStackTrace();
    }
  }

  public void removeAnimationHistory() {
    if (scroller != null) {
      leftPane.remove(scroller);
      leftPane.setDividerLocation(0);
    }
  }


  public AnimationHistory getAnimationHistory() {
    return animBox;
  }
}